#
# Spec file for OCFS2 on RHEL5
#

# Macros
# This one is hardcoded because, well, it belongs there
%define _prefix /usr
# Because RPM is dumb
%define _unpackaged_files_terminate_build 0

# Turn ons and offs
%define builddef        1
%define buildpae        0
%define buildxen        0
%define builddebug	0

%ifarch i686
%define karch		i686
%define buildpae        1
%define buildxen        1
%define builddebug	1
%endif

%ifarch x86_64
%define karch		x86_64
%define buildxen        1
%define builddebug	1
%endif

%ifarch ia64
%define karch		ia64
%define buildxen        1
%define builddebug	1
%endif

%ifarch ppc64
%define karch		ppc64
%define builddebug	1
%endif

%ifarch s390x
%define karch		s390x
%define builddebug	1
%endif

%define dont_strip	0
%define kver		2.6.18-128.7.1.0.1.el5

# The minimum tools package required for the kernel bits.
%define tools_ver     1.4.2

Summary: The Oracle Cluster Filesystem 2.
Name: ocfs2-%{kver}
Version: 1.4.9
Release: 1.el5
License: GPL
Group: System Environment/Kernel
Source: ocfs2-1.4.9.tar.gz
URL: http://oss.oracle.com/projects/ocfs2/
Distribution: Oracle
Vendor: Oracle
Packager: Joel Becker <joel.becker@oracle.com>
Provides: ocfs2 = %{version}
AutoReqProv: no
Requires: kernel = %{kver}
Requires: ocfs2-tools >= %{tools_ver}
BuildRequires: kernel-devel = %{kver}


BuildRoot: %{_tmppath}/ocfs2-%{PACKAGE_VERSION}-%{PACKAGE_RELEASE}-root


%description
OCFS2 is the Oracle Cluster Filesystem 2.  This package is compiled for
the default kernel.


%if %{buildpae}
%package -n ocfs2-%{kver}PAE
Summary: The Oracle Cluster File System 2 for the PAE kernel.
Group: System Environment/Kernel
Provides: ocfs2 = %{version}
Requires: kernel-PAE = %{kver}
Requires: ocfs2-tools >= %{tools_ver}
BuildRequires: kernel-PAE-devel = %{kver}
AutoReqProv: no

%description -n ocfs2-%{kver}PAE
OCFS2 is the Oracle Cluster Filesystem 2.  This package is compiled for
the PAE kernel.
%endif


%if %{buildxen}
%package -n ocfs2-%{kver}xen
Summary: The Oracle Cluster File System 2 for the XEN kernel.
Group: System Environment/Kernel
Provides: ocfs2 = %{version}
Requires: kernel-xen = %{kver}
Requires: ocfs2-tools >= %{tools_ver}
BuildRequires: kernel-xen-devel = %{kver}
AutoReqProv: no

%description -n ocfs2-%{kver}xen
OCFS2 is the Oracle Cluster Filesystem 2.  This package is compiled for
the XEN kernel.
%endif


%if %{builddebug}
%package -n ocfs2-%{kver}debug
Summary: The Oracle Cluster File System 2 for the debug kernel.
Group: System Environment/Kernel
Provides: ocfs2 = %{version}
Requires: kernel-debug = %{kver}
Requires: ocfs2-tools >= %{tools_ver}
BuildRequires: kernel-debug-devel = %{kver}
AutoReqProv: no

%description -n ocfs2-%{kver}debug
OCFS2 is the Oracle Cluster Filesystem 2.  This package is compiled for
the debug kernel.
%endif


%prep
%setup -n ocfs2-%{version}


%build

local_configure()
{
	./configure					\
		--prefix=%{_prefix}			\
		--exec-prefix=%{_exec_prefix}		\
		--bindir=%{_bindir}			\
		--sbindir=%{_sbindir}			\
		--sysconfdir=%{_sysconfdir}		\
		--datadir=%{_datadir}			\
		--includedir=%{_includedir}             \
		--libdir=%{_libdir}			\
		--libexecdir=%{_libexecdir}		\
		--localstatedir=%{_localstatedir}	\
		--sharedstatedir=%{_sharedstatedir}	\
		--mandir=%{_mandir}			\
		--infodir=%{_infodir}			\
		--with-vendor=rhel5			\
		--with-vendorkernel="$1"
}

strip_modules()
{
%if %{dont_strip}
	return
%endif

	# Mark modules executable so that brp-strip can strip them.
	# This requires the <percent>install section to exist.
	find "$1" -name "*.ko" -type f | xargs chmod u+x
}

autoconf

%if %{builddef}
local_configure "%{kver}"

make V=0
make DESTDIR="$RPM_BUILD_ROOT" INSTALL_MOD_PATH='$(DESTDIR)' install 

# 2.6 kbuild can't do this install nicely
EXTRA_MODLIB="${RPM_BUILD_ROOT}/lib/modules/%{kver}/extra/"
INST_MODLIB="${RPM_BUILD_ROOT}/lib/modules/%{kver}/kernel"
for i in ocfs2/ ocfs2/dlm/ ocfs2/cluster/
do
	mkdir -p "${INST_MODLIB}/fs/$i"
	mv "${EXTRA_MODLIB}"/$i/ocfs2*.ko "${INST_MODLIB}/fs/$i"
	rm -f "${EXTRA_MODLIB}"/$i/*.ko
done
strip_modules "${INST_MODLIB}"
make clean
%endif

%if %{buildpae}
local_configure "%{kver}PAE"

make V=0
make DESTDIR="$RPM_BUILD_ROOT" INSTALL_MOD_PATH='$(DESTDIR)' install

# 2.6 kbuild can't do this install nicely
EXTRA_MODLIB="${RPM_BUILD_ROOT}/lib/modules/%{kver}PAE/extra/"
INST_MODLIB="${RPM_BUILD_ROOT}/lib/modules/%{kver}PAE/kernel"
for i in ocfs2/ ocfs2/dlm/ ocfs2/cluster/
do
	mkdir -p "${INST_MODLIB}/fs/$i"
	mv "${EXTRA_MODLIB}"/$i/ocfs2*.ko "${INST_MODLIB}/fs/$i"
	rm -f "${EXTRA_MODLIB}"/$i/*.ko
done
strip_modules "${INST_MODLIB}"
make clean
%endif

%if %{buildxen}
local_configure "%{kver}xen"

make V=0
make DESTDIR="$RPM_BUILD_ROOT" INSTALL_MOD_PATH='$(DESTDIR)' install

# 2.6 kbuild can't do this install nicely
EXTRA_MODLIB="${RPM_BUILD_ROOT}/lib/modules/%{kver}xen/extra/"
INST_MODLIB="${RPM_BUILD_ROOT}/lib/modules/%{kver}xen/kernel"
for i in ocfs2/ ocfs2/dlm/ ocfs2/cluster/
do
	mkdir -p "${INST_MODLIB}/fs/$i"
	mv "${EXTRA_MODLIB}"/$i/ocfs2*.ko "${INST_MODLIB}/fs/$i"
	rm -f "${EXTRA_MODLIB}"/$i/*.ko
done
strip_modules "${INST_MODLIB}"
make clean
%endif

%if %{builddebug}
local_configure "%{kver}debug"

make V=0
make DESTDIR="$RPM_BUILD_ROOT" INSTALL_MOD_PATH='$(DESTDIR)' install

# 2.6 kbuild can't do this install nicely
EXTRA_MODLIB="${RPM_BUILD_ROOT}/lib/modules/%{kver}debug/extra/"
INST_MODLIB="${RPM_BUILD_ROOT}/lib/modules/%{kver}debug/kernel"
for i in ocfs2/ ocfs2/dlm/ ocfs2/cluster/
do
	mkdir -p "${INST_MODLIB}/fs/$i"
	mv "${EXTRA_MODLIB}"/$i/ocfs2*.ko "${INST_MODLIB}/fs/$i"
	rm -f "${EXTRA_MODLIB}"/$i/*.ko
done
strip_modules "${INST_MODLIB}"
make clean
%endif

%install
# We don't do anything here, but it is required to force RPM
# magic behaviors ... thanks guys.

%clean
rm -rf "$RPM_BUILD_ROOT"

%if %{builddef}
%post
depmod -ae %{kver}

%files
%defattr(-,root,root)
/lib/modules/%{kver}/kernel/fs
%endif

%if %{buildpae}
%post -n ocfs2-%{kver}PAE
depmod -ae %{kver}PAE

%files -n ocfs2-%{kver}PAE
%defattr(-,root,root)
/lib/modules/%{kver}PAE/kernel/fs
%endif

%if %{buildxen}
%post -n ocfs2-%{kver}xen
depmod -ae %{kver}xen

%files -n ocfs2-%{kver}xen
%defattr(-,root,root)
/lib/modules/%{kver}xen/kernel/fs
%endif

%if %{builddebug}
%post -n ocfs2-%{kver}debug
depmod -ae %{kver}debug

%files -n ocfs2-%{kver}debug
%defattr(-,root,root)
/lib/modules/%{kver}debug/kernel/fs
%endif

%changelog
* Wed May 04 2011 Tristan Ye <tristan.ye@oracle.com>
- Backport the discontig block group features from mainline ocfs2
  into EL5.x kernels

* Mon Nov 12 2007 Sunil Mushran <sunil.mushran@oracle.com>
- Add support to build modules for kernel-debug for RHEL5

* Thu Apr 12 2007 Sunil Mushran <sunil.mushran@oracle.com>
- Add PAE and xen for RHEL5

* Wed Feb 21 2007 Joel Becker <joel.becker@oracle.com>
- Modify for rhel5

* Thu Jun 22 2006 Sunil Mushran <sunil.mushran@oracle.com>
- Add largesmp

* Mon Jan 24 2004 Manish Singh <manish.singh@oracle.com>
- Initial rpm spec file
